/**
 * ArrayExamples.java
 */
import javax.swing.JOptionPane;

public class ArrayExamples {

  public static void main( String args[] )
  {
    int m = 10, n = 20;
    int a[] = { 10, 20 };

    /* pass by value vs pass by reference */

    System.out.println( "before swap:" );
    System.out.println( "m is " + m + " n is " + n );
    System.out.println( "a[0] is " + a[0] + " a[1] is " + a[1] );

    swap1( m, n );
    swap2( a );

    System.out.println( "before swap:" );
    System.out.println( "m is " + m + " n is " + n );
    System.out.println( "a[0] is " + a[0] + " a[1] is " + a[1] );


    /* input an array */
  
    // first get the number of elements
    String s = JOptionPane.showInputDialog( "Number of elements in array?" );
    int l = Integer.parseInt(s);

    // declaration and allocation
    int aa[] = new int[l];

    // get the values of array elements
    for( int i=0 ; i < aa.length ; ++i )
    {
      s = JOptionPane.showInputDialog( "element " + (i+1) + "?" );
      aa[i] = Integer.parseInt( s );
    }


    /* print out an array */

    // print array
    for( int i=0 ; i < aa.length ; ++i ) System.out.println( aa[i] + " " );
    System.out.println();

    // or do it with a method
    printArray( aa );


    /* copy part of array to a new array. e.g. copy all elements of
     * arrayX to arrayY except the first 3.
     */

    int arrayX[] = { 1, 2, 3, 4, 5, 6, 7, 8 };
    int arrayY[] = new int[ arrayX.length-3 ];

    for( int i=0 ; i < arrayY.length ; ++i ) arrayY[i] = arrayX[i+3];

    System.out.println( "arrayX is:" );
    printArray( arrayX );
    System.out.println( "arrayY is:" );
    printArray( arrayY );


    /* find the smallest element in a array using a recurive method */

    int b[] = { 10, 3, 5, 20, -5, 33, 26 };
    System.out.println( "the smallest element in " );
    printArray( b );
    System.out.println( "is " + recursiveMin(b,0) );


    System.exit(0);
  }

  /**
   * Tries to sway two given integers, but it won't work because
   * parameters of primitive types are passed by value.
   */
  public static void swap1( int x, int y )
  {
    int tmp = x;
    x = y;
    y = tmp;
  }


  /**
   * swaps the first two elements of an array. Note that objects,
   * including arrays, are passed by reference.
   */
  public static void swap2( int x[] )
  {
    int tmp = x[0];
    x[0] = x[1];
    x[1] = tmp;
  }

  
  /**
   * Prints out an array.
   */
  public static void printArray( int x[] )
  {
    for( int i=0 ; i < x.length ; ++i )
      System.out.print( x[i] + " " );
    System.out.println();
  }


  /**
   * Finds the smallest element in a given array starting from the
   * startIndex. For example, if the array x is { 10, 3, 5, 2, 7 },
   * and the startIndex is 2, then recurMin( x, 2 ) should return
   * the smallest of { 5, 2, 7}, which is 2.
   */
  public static int recursiveMin( int x[], int startIndex )
  {
    // if startIndex is the index of the last element, then
    // there's only one element in this arrange, so it is the
    // smallest _in this arrange_.
    if( startIndex == x.length - 1 ) return x[ x.length-1 ];
    
    // otherwise compare the element at the startIndex with the
    // smallest among the rest of the elements
    else
    {
      // smallest in the range from startIndex+1 to the end of
      // the array
      int small = recursiveMin( x, startIndex+1 );

      if( x[startIndex] < small )	return x[startIndex];
      else				return small;
    }
  }
    
} // end of class ArrayExamples

